<?php
	$only_numeric = isset($only_numeric) && is_bool($only_numeric) ? $only_numeric : false;
	$allow_dot    = isset($allow_dot)    && is_bool($allow_dot)    ? $allow_dot    : false;
	$readonly     = isset($readonly)     && is_bool($readonly)     ? $readonly     : false;
	$width        = isset($width)        && !empty($width)         ? $width        : '100%';
	$default_text = isset($default_text) && !empty($default_text)  ? $default_text : '';
	
	$saved_value = isset($saved_value) ? PostMetaManagerHelper::esc_attr($saved_value) : '';
	if (empty($saved_value)) $saved_value = $default_text;
?>
<input
	type="text"
	name="<?php _e($identifier) ?>"
	id="<?php _e($identifier) ?>"
	value="<?php _e($saved_value) ?>"
	class="<?php _e($only_numeric ? 'ONLY_NUMERIC' : '') ?>"
	style="width: 100%; max-width: <?php _e($width) ?>; <?php _e(isset($style) && !empty($style) ? $style : '') ?>"
	<?php _e(isset($readonly) && $readonly === true ? 'readonly="readonly"' : '') ?>
/>
<?php if ($only_numeric) { ?>
	<script type="text/javascript">
		jQuery(function ($)
		{
			$("#<?php _e(PostMetaManagerHelper::sanitize_css_selector($identifier)) ?>").onlyNumbers({ allowDot: <?php _e($allow_dot ? 'true' : 'false') ?> });
		});
	</script>
<?php } ?>