<?php
	if ( !(is_array($items) && count($items) > 0) ) return;
	$sortable  = isset($sortable)  && is_bool($sortable) ? $sortable  : false;
	$max_items = isset($max_items) && $max_items > 1     ? $max_items : 1;
	$depth     = isset($depth)     && $depth > 1         ? $depth     : 1;
	
	$saved_value = str_replace('&quot;', '"', $saved_value);
?>
<div class="multiNestablePickerWrp MULTI_POST_PICKER_NESTED_WRP <?php _e($field_data['key']) ?>">
	<div class="dd" style="display: none;">
		<ol class="dd-list">
			<li class="dd-item dd3-item multiNestablePickerNestedDropdown MULTI_POST_PICKER_NESTED_DROPDOWN <?php _e($field_data['key']) ?>">
				<div class="dd-handle dd3-handle">Drag</div>
				<div class="dd3-content <?php _e($field_data['key']) ?> <?php if ($sortable) { ?>ui-state-default<?php } ?> <?php _e($field_data['additional_class']) ?>">
					<?php PostMetaManagerHelper::generate_dropdown($items) ?>
					<a href="#" class="MULTI_POST_PICKER_NESTED_REMOVE <?php _e($field_data['key']) ?>">- Remove</a>
				</div>	
			</li>
		</ol>
	</div>
	<a href="#" class="MULTI_POST_PICKER_NESTED_ADD <?php _e($field_data['key']) ?>">+ Add</a>
	<div class="dd nestable_<?php _e($field_data['key']) ?>">
		<ol class="dd-list MULTI_POST_PICKER_NESTED_CANVAS <?php _e($field_data['key']) ?>">
			<?php 
				$i = 0;
				if (!is_array($saved_value)) {
					if (strlen($saved_value) > 0) {
						$saved_value = json_decode($saved_value);
					} else {
						$saved_value = array();
					}
				}
				if (is_array($saved_value)) {
					foreach ($saved_value as $value) {
						$saved_value = $value->id;
						$children = $value->children;
						?>
						<li class="dd-item dd3-item MULTI_POST_PICKER_NESTED_DROPDOWN <?php _e($field_data['key']) ?>" data-id="<?php _e($saved_value) ?>">
							<div class="dd-handle dd3-handle">Drag</div>
							<div class="dd3-content <?php _e($field_data['key']) ?> <?php if ($sortable) { ?>ui-state-default<?php } ?> <?php _e($field_data['additional_class']) ?>">
								<?php PostMetaManagerHelper::generate_dropdown($items, $saved_value) ?>
								<a href="#" class="MULTI_POST_PICKER_NESTED_REMOVE <?php _e($field_data['key']) ?>">- Remove</a>
							</div>	
							<?php
								if (!empty($children)) { 
									foreach ($children as $child) {
										$saved_value = $child->id;
										?>
										<ol class="dd-list">
											<li class="dd-item dd3-item MULTI_POST_PICKER_NESTED_DROPDOWN <?php _e($field_data['key']) ?>" data-id="<?php _e($saved_value) ?>">
												<div class="dd-handle dd3-handle">Drag</div>
												<div class="dd3-content <?php _e($field_data['key']) ?> <?php if ($sortable) { ?>ui-state-default<?php } ?> <?php _e($field_data['additional_class']) ?>">
													<?php PostMetaManagerHelper::generate_dropdown($items, $saved_value) ?>
													<a href="#" class="MULTI_POST_PICKER_NESTED_REMOVE <?php _e($field_data['key']) ?>">- Remove</a>
												</div>
											</li>
										</ol>
								<?php } ?>
							<?php } ?>					
						</li>												
						<?php
						$i++;
					}
				}
			?>
		</ol>
	</div>
	<input type="hidden" value="" name="<?php _e($identifier) ?>" class="HIDDEN_NESTED_FIELD_<?php _e($field_data['key']) ?>">									
	<script type="text/javascript">
		jQuery(function ($)
		{
			var $multiNestablePickerRoot     = $(".MULTI_POST_PICKER_NESTED_WRP.<?php _e($field_data['key']) ?>");												
			var $multiNestablePickerDropDown = $multiNestablePickerRoot.find(".MULTI_POST_PICKER_NESTED_DROPDOWN.<?php _e($field_data['key']) ?>").first();
			var $multiNestablePickerAdd      = $multiNestablePickerRoot.find(".MULTI_POST_PICKER_NESTED_ADD.<?php _e($field_data['key']) ?>");
			var $multiNestablePickerRemove   = $multiNestablePickerRoot.find(".MULTI_POST_PICKER_NESTED_REMOVE.<?php _e($field_data['key']) ?>");
			var $hiddenField             = $(".HIDDEN_NESTED_FIELD_<?php _e($field_data['key']) ?>");
			var maxItems                 = <?php _e($max_items) ?>;
			
			function serializedList ()
			{
				<?php _e(!$sortable ? 'return;' : '') ?> // ???
				return JSON.stringify($(".nestable_<?php _e($field_data['key']) ?>").nestable("serialize"));
			}
			
			$multiNestablePickerRoot.find(".MULTI_POST_PICKER_NESTED_DROPDOWN.<?php _e($field_data['key']) ?> select").live("change", function ()
			{
				var $this = $(this);
				var value = $this.val();
				$this.parents(".MULTI_POST_PICKER_NESTED_DROPDOWN").first().attr("data-id", value).data("id", value);
				$hiddenField.val(serializedList());
			});
			
			function reArrangeIndex ()
			{
				$multiNestablePickerRoot.find(".MULTI_POST_PICKER_NESTED_CANVAS select").each(function (i)
				{
					$(this).attr("name", "<?php _e($identifier . '_tmp') ?>[" + i + "]");
				});
			}
			
			$multiNestablePickerAdd.click(function (e)
			{
				e.preventDefault();
				var idx = $multiNestablePickerRoot.find(".MULTI_POST_PICKER_NESTED_CANVAS select").length;
				if (idx >= maxItems) return;
				var $dropdown = $multiNestablePickerDropDown.clone();
				var $select   = $dropdown.find("select");
				var attrName  = $select.attr("name");
				$select.attr("name", attrName + "[" + idx + "]");
				$multiNestablePickerRoot.find(".MULTI_POST_PICKER_NESTED_CANVAS.<?php _e($field_data['key']) ?>").append($dropdown.removeClass("multiNestablePickerNestedDropdown"));
				reArrangeIndex();
				var value = $dropdown.find("option").first().val();
				$dropdown.attr("data-id", value).data("id", value);
				$hiddenField.val(serializedList());
			});
			
			$multiNestablePickerRemove.live("click", function (e)
			{
				e.preventDefault();
				$(this).parents(".MULTI_POST_PICKER_NESTED_DROPDOWN").first().remove();
				reArrangeIndex();
				$hiddenField.val(serializedList());
			});	
				
			<?php if ($sortable) { ?>
				$(".nestable_<?php _e($field_data['key']) ?>").nestable({
					maxDepth: <?php _e($depth) ?>
				}).on("change", function ()
				{
					$hiddenField.val(serializedList());
				});
			<?php } ?>
			
			$hiddenField.val(serializedList());
		});
	</script>
</div>